=== src/Bitmap_cubical_complex/benchmark/CMakeLists.txt ===
add_executable_with_targets(bitmap_cubical_complex_benchmark bitmap_cubical_complex_benchmark.cpp TBB::tbb)
