=== src/Bottleneck_distance/benchmark/CMakeLists.txt ===
add_executable_with_targets(bottleneck_chrono bottleneck_chrono.cpp CGAL::CGAL TBB::tbb)
