=== debian/changelog ===
gudhi (3.11.0+dfsg-1) unstable; urgency=medium

  * New upstream version.
  * Refresh patches.
    - Drop patch for handling isolated zero-simplices, upstreamed.
  * Standards-version 4.7.2.0. No changes needed.

 -- Gard Spreemann <gspr@nonempty.org>  Mon, 24 Mar 2025 16:08:54 +0100
