=== debian/control ===
Source: gudhi
Maintainer: Gard Spreemann <gspr@nonempty.org>
Section: math
Priority: optional
Standards-Version: 4.7.2.0
Build-Depends: cmake (>= 3.15),
               cython3 (>= 3.0.0),
               debhelper-compat (= 13),
               dh-python,
               libboost-filesystem-dev (>= 1.71),
               libboost-program-options-dev (>= 1.71),
               libboost-system-dev (>= 1.71),
               libboost-test-dev (>= 1.71),
               libboost-thread-dev (>= 1.71),
               libboost-timer-dev (>= 1.71),
               libcgal-dev (>= 5.5.1),
               libeigen3-dev (>= 3.3.0),
               libgmp-dev (>= 4.2),
               libhera-dev (>= 2.0.0),
               libtbb-dev,
               pybind11-dev,
               python3-all-dev,
               python3-eagerpy,
               python3-matplotlib,
               python3-numpy,
               python3-pot,
               python3-pybind11,
               python3-pytest,
               python3-scipy,
               python3-setuptools,
               python3-sklearn,
               python3-tk
Build-Depends-Indep: doxygen,
                     graphviz
Rules-Requires-Root: no
Homepage: https://gudhi.inria.fr/
Vcs-Browser: https://salsa.debian.org/gspr/gudhi
Vcs-Git: https://salsa.debian.org/gspr/gudhi.git -b debian/sid

Package: libgudhi-dev
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends: libboost-filesystem-dev (>= 1.71),
         libboost-program-options-dev (>= 1.71),
         libboost-system-dev (>= 1.71),
         libboost-test-dev (>= 1.71),
         libboost-thread-dev (>= 1.71),
         libboost-timer-dev (>= 1.71),
         libcgal-dev (>= 5.5.1),
         libeigen3-dev (>= 3.3.0),
         libgmp-dev (>= 4.2),
         libtbb-dev,
         ${misc:Depends}
Suggests: libgudhi-doc, libgudhi-examples, libhera-dev
Description: Generic open source C++ library for topological data analysis
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 This package contains the header files. See the libgudhi-examples
 package for example programs using the library.

Package: libgudhi-examples
Section: misc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: libgudhi-dev, libgudhi-doc
Description: Example programs for the GUDHI library
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 This package contains some source code examples.

Package: libgudhi-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-mathjax, ${misc:Depends}
Description: Documentation for the GUDHI library
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 This package contains documentation.

Package: python3-gudhi
Section: python
Architecture: amd64 arm64 i386 ia64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64 x32
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Recommends: python3-eagerpy,
            python3-matplotlib,
            python3-pot,
            python3-scipy,
            python3-sklearn
Description: Python 3 interface to the GUDHI library
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 This package contains GUDHI's Python (3) interface.

Package: gudhi-utils
Section: math
Architecture: amd64 arm64 i386 ia64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64 x32
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Utilities from the GUDHI library
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 This package contains some utilities built with the GUDHI library.
